#ifndef __GMKRC_H__
#define __GMKRC_H__

#include <linux/sched.h>

#ifdef _gm_h_
#error Let gmkrc.h include gm.h with correct #define
#endif

#define GM_BUILDING_GM 1
#define GM_BUILDING_INTERNALS 1
#define GM_SIZEOF_UP_T 8
#include "gm.h.h"
#include "gm_internal.h.h"


#define GMKRC_VERSION "0.1"


extern gm_status_t
gmkrc_open(struct gm_port **p,
	   unsigned int unit,
	   unsigned int port,
	   const char *port_name,
	   enum gm_api_version version);

extern void
gmkrc_close(struct gm_port *p);

extern gm_status_t
gmkrc_register_memory(struct gm_port *port,
		      void *buffer,
		      unsigned long length);

extern gm_status_t
gmkrc_deregister_memory(struct gm_port *port,
			void *buffer,
			unsigned long length);

extern void
gmkrc_send_with_callback(struct gm_port *port,
			 void *message,
			 unsigned int size,
			 gm_size_t len,
			 unsigned int priority,
			 unsigned int target_node_id,
			 unsigned int target_port_id,
			 gm_send_completion_callback_t callback,
			 void *context);

extern void
gmkrc_provide_receive_buffer_with_tag(struct gm_port *port,
				      void *buffer,
				      unsigned int size,
				      unsigned int priority,
				      unsigned int tag);
extern inline void
gmkrc_provide_receive_buffer(struct gm_port *port,
			     void *buffer,
			     unsigned int size,
			     unsigned int priority)
{
  gmkrc_provide_receive_buffer_with_tag(port, buffer, size, priority, 0);
}

extern inline gm_remote_ptr_t gmkrc_get_remote_ptr(void *ptr)
{
  gm_up_t uptr = GM_PTR_TO_UP (ptr);

  if ( (unsigned long)ptr < PAGE_OFFSET )
    uptr |= GM_PTR_TO_UP (current->mm) << 32;

  return (gm_remote_ptr_t) uptr;
}

#endif /* __GMKRC_H__ */
