#ifndef __GMKRC_MESSAGES_H__
#define __GMKRC_MESSAGES_H__


/***********************************
 * General Purpose Kernel Messages *
 ***********************************/

#define NOTICE(args...) \
printk(KERN_INFO "GMKRC: " args)

#define ERROR(args...) \
printk(KERN_INFO "GMKRC error: " args)


/**********************
 * Debugging Messages *
 **********************/

#if CONFIG_GMKRC_DEBUG

extern int gmkrc_debug;

#define LOG(level, args...)                  \
do { if ( level <= gmkrc_debug ) {           \
printk(KERN_INFO "GMKRC " #level ": " args); \
} } while ( 0 )

#else /* CONFIG_GMKRC_DEBUG */

#define LOG(args...) do { } while ( 0 )

#endif /* CONFIG_GMKRC_DEBUG */


#endif /* __GMKRC_MESSAGES_H__ */
